# coding: utf-8

"""
    VMware Aria Automation Pipelines APIs

    Aria Automation Pipelines is a continuous integration and continuous delivery (CICD) tool that you use to build Pipelines that model the software release process in your DevOps lifecycle. By creating Pipelines, you build the code infrastructure that delivers your software rapidly and continuously.  This page describes the RESTful APIs for Aria Automation Pipelines. The APIs facilitate CRUD operations on the various resources and entities used throughout Aria Automation Pipelines (Pipelines, Endpoints, Variables, etc.) and allow operations on them (executing a Pipeline, validating an Endpoint connection, etc.).  The APIs that list collections of resources  also support OData like implementation. Below query params can be used across Aria Automation Pipelines entities.  Example:  1. `$orderby` - returns a result with the rows being sorted by the values of provided attribute.      ```/codestream/api/endpoints?$orderby=name%20desc```  2. `$top`, `$skip` - `$top` returns the requested number of resources. Used with `$skip`, the client can skip a given number of resources.      ```/codestream/api/endpoints?$expand=true&$top=10&$skip=2```  3. `page` and `$size` - page used in conjunction with `$size` helps in pagination of resources.      ```/codestream/api/endpoints?$expand=true&page=0&$size=5```  4. `$filter` - `$filter` returns a subset of resources that satisfy the given predicate expression.      ```     /codestream/api/endpoints?$filter=startswith(name, 'ABC')     /codestream/api/endpoints?$filter=toupper(name) eq 'ABCD-JENKINS'     /codestream/api/endpoints?$filter=substringof(%27bc%27,tolower(name))     /codestream/api/endpoints?$filter=name eq 'ABCD' and project eq 'demo'   # noqa: E501

    OpenAPI spec version: 2019-10-17
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class Execution2(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'create_time_in_micros': 'int',
        'duration_in_micros': 'int',
        'executed_by': 'str',
        '_global': 'bool',
        'input_meta': 'dict(str, PropertyMetaData1)',
        'link': 'str',
        'nested': 'bool',
        'output_meta': 'dict(str, PropertyMetaData1)',
        'pipeline_link': 'str',
        'project_id': 'str',
        'request_time_in_micros': 'int',
        'rollback': 'bool',
        'source': 'str',
        'total_duration_in_micros': 'int',
        'triggered_by': 'str',
        'update_time_in_micros': 'int',
        'comments': 'str',
        'created_at': 'str',
        'created_by': 'str',
        'description': 'str',
        'icon': 'str',
        'id': 'str',
        'index': 'int',
        'input': 'object',
        'name': 'str',
        'notifications': 'list[Notification1]',
        'output': 'object',
        'project': 'str',
        'reason': 'str',
        'resumed_at': 'str',
        'stage_order': 'list[str]',
        'stages': 'dict(str, StageExecution1)',
        'starred': 'PipelineStarredProperty',
        'status': 'str',
        'status_message': 'str',
        'tags': 'list[str]',
        'updated_at': 'str',
        'updated_by': 'str',
        'version': 'str',
        'workspace_results': 'list[WorkspaceResult1]'
    }

    attribute_map = {
        'create_time_in_micros': '_createTimeInMicros',
        'duration_in_micros': '_durationInMicros',
        'executed_by': '_executedBy',
        '_global': '_global',
        'input_meta': '_inputMeta',
        'link': '_link',
        'nested': '_nested',
        'output_meta': '_outputMeta',
        'pipeline_link': '_pipelineLink',
        'project_id': '_projectId',
        'request_time_in_micros': '_requestTimeInMicros',
        'rollback': '_rollback',
        'source': '_source',
        'total_duration_in_micros': '_totalDurationInMicros',
        'triggered_by': '_triggeredBy',
        'update_time_in_micros': '_updateTimeInMicros',
        'comments': 'comments',
        'created_at': 'createdAt',
        'created_by': 'createdBy',
        'description': 'description',
        'icon': 'icon',
        'id': 'id',
        'index': 'index',
        'input': 'input',
        'name': 'name',
        'notifications': 'notifications',
        'output': 'output',
        'project': 'project',
        'reason': 'reason',
        'resumed_at': 'resumed_at',
        'stage_order': 'stageOrder',
        'stages': 'stages',
        'starred': 'starred',
        'status': 'status',
        'status_message': 'statusMessage',
        'tags': 'tags',
        'updated_at': 'updatedAt',
        'updated_by': 'updatedBy',
        'version': 'version',
        'workspace_results': 'workspaceResults'
    }

    def __init__(self, create_time_in_micros=None, duration_in_micros=None, executed_by=None, _global=None, input_meta=None, link=None, nested=None, output_meta=None, pipeline_link=None, project_id=None, request_time_in_micros=None, rollback=None, source=None, total_duration_in_micros=None, triggered_by=None, update_time_in_micros=None, comments=None, created_at=None, created_by=None, description=None, icon=None, id=None, index=None, input=None, name=None, notifications=None, output=None, project=None, reason=None, resumed_at=None, stage_order=None, stages=None, starred=None, status=None, status_message=None, tags=None, updated_at=None, updated_by=None, version=None, workspace_results=None):  # noqa: E501
        """Execution2 - a model defined in Swagger"""  # noqa: E501
        self._create_time_in_micros = None
        self._duration_in_micros = None
        self._executed_by = None
        self.__global = None
        self._input_meta = None
        self._link = None
        self._nested = None
        self._output_meta = None
        self._pipeline_link = None
        self._project_id = None
        self._request_time_in_micros = None
        self._rollback = None
        self._source = None
        self._total_duration_in_micros = None
        self._triggered_by = None
        self._update_time_in_micros = None
        self._comments = None
        self._created_at = None
        self._created_by = None
        self._description = None
        self._icon = None
        self._id = None
        self._index = None
        self._input = None
        self._name = None
        self._notifications = None
        self._output = None
        self._project = None
        self._reason = None
        self._resumed_at = None
        self._stage_order = None
        self._stages = None
        self._starred = None
        self._status = None
        self._status_message = None
        self._tags = None
        self._updated_at = None
        self._updated_by = None
        self._version = None
        self._workspace_results = None
        self.discriminator = None
        if create_time_in_micros is not None:
            self.create_time_in_micros = create_time_in_micros
        if duration_in_micros is not None:
            self.duration_in_micros = duration_in_micros
        if executed_by is not None:
            self.executed_by = executed_by
        if _global is not None:
            self._global = _global
        if input_meta is not None:
            self.input_meta = input_meta
        if link is not None:
            self.link = link
        if nested is not None:
            self.nested = nested
        if output_meta is not None:
            self.output_meta = output_meta
        if pipeline_link is not None:
            self.pipeline_link = pipeline_link
        if project_id is not None:
            self.project_id = project_id
        if request_time_in_micros is not None:
            self.request_time_in_micros = request_time_in_micros
        if rollback is not None:
            self.rollback = rollback
        if source is not None:
            self.source = source
        if total_duration_in_micros is not None:
            self.total_duration_in_micros = total_duration_in_micros
        if triggered_by is not None:
            self.triggered_by = triggered_by
        if update_time_in_micros is not None:
            self.update_time_in_micros = update_time_in_micros
        if comments is not None:
            self.comments = comments
        if created_at is not None:
            self.created_at = created_at
        if created_by is not None:
            self.created_by = created_by
        if description is not None:
            self.description = description
        if icon is not None:
            self.icon = icon
        if id is not None:
            self.id = id
        if index is not None:
            self.index = index
        if input is not None:
            self.input = input
        self.name = name
        if notifications is not None:
            self.notifications = notifications
        if output is not None:
            self.output = output
        if project is not None:
            self.project = project
        if reason is not None:
            self.reason = reason
        if resumed_at is not None:
            self.resumed_at = resumed_at
        if stage_order is not None:
            self.stage_order = stage_order
        if stages is not None:
            self.stages = stages
        if starred is not None:
            self.starred = starred
        if status is not None:
            self.status = status
        if status_message is not None:
            self.status_message = status_message
        if tags is not None:
            self.tags = tags
        if updated_at is not None:
            self.updated_at = updated_at
        if updated_by is not None:
            self.updated_by = updated_by
        if version is not None:
            self.version = version
        if workspace_results is not None:
            self.workspace_results = workspace_results

    @property
    def create_time_in_micros(self):
        """Gets the create_time_in_micros of this Execution2.  # noqa: E501

        This field is provided for backward compatibility. Contains the same value as the 'createdAt' field as a UNIX timestamp in microseconds  # noqa: E501

        :return: The create_time_in_micros of this Execution2.  # noqa: E501
        :rtype: int
        """
        return self._create_time_in_micros

    @create_time_in_micros.setter
    def create_time_in_micros(self, create_time_in_micros):
        """Sets the create_time_in_micros of this Execution2.

        This field is provided for backward compatibility. Contains the same value as the 'createdAt' field as a UNIX timestamp in microseconds  # noqa: E501

        :param create_time_in_micros: The create_time_in_micros of this Execution2.  # noqa: E501
        :type: int
        """

        self._create_time_in_micros = create_time_in_micros

    @property
    def duration_in_micros(self):
        """Gets the duration_in_micros of this Execution2.  # noqa: E501


        :return: The duration_in_micros of this Execution2.  # noqa: E501
        :rtype: int
        """
        return self._duration_in_micros

    @duration_in_micros.setter
    def duration_in_micros(self, duration_in_micros):
        """Sets the duration_in_micros of this Execution2.


        :param duration_in_micros: The duration_in_micros of this Execution2.  # noqa: E501
        :type: int
        """

        self._duration_in_micros = duration_in_micros

    @property
    def executed_by(self):
        """Gets the executed_by of this Execution2.  # noqa: E501


        :return: The executed_by of this Execution2.  # noqa: E501
        :rtype: str
        """
        return self._executed_by

    @executed_by.setter
    def executed_by(self, executed_by):
        """Sets the executed_by of this Execution2.


        :param executed_by: The executed_by of this Execution2.  # noqa: E501
        :type: str
        """

        self._executed_by = executed_by

    @property
    def _global(self):
        """Gets the _global of this Execution2.  # noqa: E501


        :return: The _global of this Execution2.  # noqa: E501
        :rtype: bool
        """
        return self.__global

    @_global.setter
    def _global(self, _global):
        """Sets the _global of this Execution2.


        :param _global: The _global of this Execution2.  # noqa: E501
        :type: bool
        """

        self.__global = _global

    @property
    def input_meta(self):
        """Gets the input_meta of this Execution2.  # noqa: E501


        :return: The input_meta of this Execution2.  # noqa: E501
        :rtype: dict(str, PropertyMetaData1)
        """
        return self._input_meta

    @input_meta.setter
    def input_meta(self, input_meta):
        """Sets the input_meta of this Execution2.


        :param input_meta: The input_meta of this Execution2.  # noqa: E501
        :type: dict(str, PropertyMetaData1)
        """

        self._input_meta = input_meta

    @property
    def link(self):
        """Gets the link of this Execution2.  # noqa: E501

        Partial URL that provides details of the resource.  # noqa: E501

        :return: The link of this Execution2.  # noqa: E501
        :rtype: str
        """
        return self._link

    @link.setter
    def link(self, link):
        """Sets the link of this Execution2.

        Partial URL that provides details of the resource.  # noqa: E501

        :param link: The link of this Execution2.  # noqa: E501
        :type: str
        """

        self._link = link

    @property
    def nested(self):
        """Gets the nested of this Execution2.  # noqa: E501


        :return: The nested of this Execution2.  # noqa: E501
        :rtype: bool
        """
        return self._nested

    @nested.setter
    def nested(self, nested):
        """Sets the nested of this Execution2.


        :param nested: The nested of this Execution2.  # noqa: E501
        :type: bool
        """

        self._nested = nested

    @property
    def output_meta(self):
        """Gets the output_meta of this Execution2.  # noqa: E501


        :return: The output_meta of this Execution2.  # noqa: E501
        :rtype: dict(str, PropertyMetaData1)
        """
        return self._output_meta

    @output_meta.setter
    def output_meta(self, output_meta):
        """Sets the output_meta of this Execution2.


        :param output_meta: The output_meta of this Execution2.  # noqa: E501
        :type: dict(str, PropertyMetaData1)
        """

        self._output_meta = output_meta

    @property
    def pipeline_link(self):
        """Gets the pipeline_link of this Execution2.  # noqa: E501


        :return: The pipeline_link of this Execution2.  # noqa: E501
        :rtype: str
        """
        return self._pipeline_link

    @pipeline_link.setter
    def pipeline_link(self, pipeline_link):
        """Sets the pipeline_link of this Execution2.


        :param pipeline_link: The pipeline_link of this Execution2.  # noqa: E501
        :type: str
        """

        self._pipeline_link = pipeline_link

    @property
    def project_id(self):
        """Gets the project_id of this Execution2.  # noqa: E501

        Contains project id of the entity  # noqa: E501

        :return: The project_id of this Execution2.  # noqa: E501
        :rtype: str
        """
        return self._project_id

    @project_id.setter
    def project_id(self, project_id):
        """Sets the project_id of this Execution2.

        Contains project id of the entity  # noqa: E501

        :param project_id: The project_id of this Execution2.  # noqa: E501
        :type: str
        """

        self._project_id = project_id

    @property
    def request_time_in_micros(self):
        """Gets the request_time_in_micros of this Execution2.  # noqa: E501


        :return: The request_time_in_micros of this Execution2.  # noqa: E501
        :rtype: int
        """
        return self._request_time_in_micros

    @request_time_in_micros.setter
    def request_time_in_micros(self, request_time_in_micros):
        """Sets the request_time_in_micros of this Execution2.


        :param request_time_in_micros: The request_time_in_micros of this Execution2.  # noqa: E501
        :type: int
        """

        self._request_time_in_micros = request_time_in_micros

    @property
    def rollback(self):
        """Gets the rollback of this Execution2.  # noqa: E501


        :return: The rollback of this Execution2.  # noqa: E501
        :rtype: bool
        """
        return self._rollback

    @rollback.setter
    def rollback(self, rollback):
        """Sets the rollback of this Execution2.


        :param rollback: The rollback of this Execution2.  # noqa: E501
        :type: bool
        """

        self._rollback = rollback

    @property
    def source(self):
        """Gets the source of this Execution2.  # noqa: E501


        :return: The source of this Execution2.  # noqa: E501
        :rtype: str
        """
        return self._source

    @source.setter
    def source(self, source):
        """Sets the source of this Execution2.


        :param source: The source of this Execution2.  # noqa: E501
        :type: str
        """

        self._source = source

    @property
    def total_duration_in_micros(self):
        """Gets the total_duration_in_micros of this Execution2.  # noqa: E501


        :return: The total_duration_in_micros of this Execution2.  # noqa: E501
        :rtype: int
        """
        return self._total_duration_in_micros

    @total_duration_in_micros.setter
    def total_duration_in_micros(self, total_duration_in_micros):
        """Sets the total_duration_in_micros of this Execution2.


        :param total_duration_in_micros: The total_duration_in_micros of this Execution2.  # noqa: E501
        :type: int
        """

        self._total_duration_in_micros = total_duration_in_micros

    @property
    def triggered_by(self):
        """Gets the triggered_by of this Execution2.  # noqa: E501


        :return: The triggered_by of this Execution2.  # noqa: E501
        :rtype: str
        """
        return self._triggered_by

    @triggered_by.setter
    def triggered_by(self, triggered_by):
        """Sets the triggered_by of this Execution2.


        :param triggered_by: The triggered_by of this Execution2.  # noqa: E501
        :type: str
        """

        self._triggered_by = triggered_by

    @property
    def update_time_in_micros(self):
        """Gets the update_time_in_micros of this Execution2.  # noqa: E501

        This field is provided for backward compatibility. Contains the same value as the 'updatedAt' field as a UNIX timestamp in microseconds  # noqa: E501

        :return: The update_time_in_micros of this Execution2.  # noqa: E501
        :rtype: int
        """
        return self._update_time_in_micros

    @update_time_in_micros.setter
    def update_time_in_micros(self, update_time_in_micros):
        """Sets the update_time_in_micros of this Execution2.

        This field is provided for backward compatibility. Contains the same value as the 'updatedAt' field as a UNIX timestamp in microseconds  # noqa: E501

        :param update_time_in_micros: The update_time_in_micros of this Execution2.  # noqa: E501
        :type: int
        """

        self._update_time_in_micros = update_time_in_micros

    @property
    def comments(self):
        """Gets the comments of this Execution2.  # noqa: E501


        :return: The comments of this Execution2.  # noqa: E501
        :rtype: str
        """
        return self._comments

    @comments.setter
    def comments(self, comments):
        """Sets the comments of this Execution2.


        :param comments: The comments of this Execution2.  # noqa: E501
        :type: str
        """

        self._comments = comments

    @property
    def created_at(self):
        """Gets the created_at of this Execution2.  # noqa: E501

        Date when the entity was created. The date is in ISO 8601 with time zone  # noqa: E501

        :return: The created_at of this Execution2.  # noqa: E501
        :rtype: str
        """
        return self._created_at

    @created_at.setter
    def created_at(self, created_at):
        """Sets the created_at of this Execution2.

        Date when the entity was created. The date is in ISO 8601 with time zone  # noqa: E501

        :param created_at: The created_at of this Execution2.  # noqa: E501
        :type: str
        """

        self._created_at = created_at

    @property
    def created_by(self):
        """Gets the created_by of this Execution2.  # noqa: E501

        The user that created this entity  # noqa: E501

        :return: The created_by of this Execution2.  # noqa: E501
        :rtype: str
        """
        return self._created_by

    @created_by.setter
    def created_by(self, created_by):
        """Sets the created_by of this Execution2.

        The user that created this entity  # noqa: E501

        :param created_by: The created_by of this Execution2.  # noqa: E501
        :type: str
        """

        self._created_by = created_by

    @property
    def description(self):
        """Gets the description of this Execution2.  # noqa: E501

        A human-friendly description.  # noqa: E501

        :return: The description of this Execution2.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this Execution2.

        A human-friendly description.  # noqa: E501

        :param description: The description of this Execution2.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def icon(self):
        """Gets the icon of this Execution2.  # noqa: E501


        :return: The icon of this Execution2.  # noqa: E501
        :rtype: str
        """
        return self._icon

    @icon.setter
    def icon(self, icon):
        """Sets the icon of this Execution2.


        :param icon: The icon of this Execution2.  # noqa: E501
        :type: str
        """

        self._icon = icon

    @property
    def id(self):
        """Gets the id of this Execution2.  # noqa: E501

        The id of this resource.  # noqa: E501

        :return: The id of this Execution2.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this Execution2.

        The id of this resource.  # noqa: E501

        :param id: The id of this Execution2.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def index(self):
        """Gets the index of this Execution2.  # noqa: E501


        :return: The index of this Execution2.  # noqa: E501
        :rtype: int
        """
        return self._index

    @index.setter
    def index(self, index):
        """Sets the index of this Execution2.


        :param index: The index of this Execution2.  # noqa: E501
        :type: int
        """

        self._index = index

    @property
    def input(self):
        """Gets the input of this Execution2.  # noqa: E501


        :return: The input of this Execution2.  # noqa: E501
        :rtype: object
        """
        return self._input

    @input.setter
    def input(self, input):
        """Sets the input of this Execution2.


        :param input: The input of this Execution2.  # noqa: E501
        :type: object
        """

        self._input = input

    @property
    def name(self):
        """Gets the name of this Execution2.  # noqa: E501

        A human-friendly name used as an identifier in APIs that support this option  # noqa: E501

        :return: The name of this Execution2.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this Execution2.

        A human-friendly name used as an identifier in APIs that support this option  # noqa: E501

        :param name: The name of this Execution2.  # noqa: E501
        :type: str
        """
        if name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    @property
    def notifications(self):
        """Gets the notifications of this Execution2.  # noqa: E501


        :return: The notifications of this Execution2.  # noqa: E501
        :rtype: list[Notification1]
        """
        return self._notifications

    @notifications.setter
    def notifications(self, notifications):
        """Sets the notifications of this Execution2.


        :param notifications: The notifications of this Execution2.  # noqa: E501
        :type: list[Notification1]
        """

        self._notifications = notifications

    @property
    def output(self):
        """Gets the output of this Execution2.  # noqa: E501


        :return: The output of this Execution2.  # noqa: E501
        :rtype: object
        """
        return self._output

    @output.setter
    def output(self, output):
        """Sets the output of this Execution2.


        :param output: The output of this Execution2.  # noqa: E501
        :type: object
        """

        self._output = output

    @property
    def project(self):
        """Gets the project of this Execution2.  # noqa: E501

        The project this entity belongs to.  # noqa: E501

        :return: The project of this Execution2.  # noqa: E501
        :rtype: str
        """
        return self._project

    @project.setter
    def project(self, project):
        """Sets the project of this Execution2.

        The project this entity belongs to.  # noqa: E501

        :param project: The project of this Execution2.  # noqa: E501
        :type: str
        """

        self._project = project

    @property
    def reason(self):
        """Gets the reason of this Execution2.  # noqa: E501


        :return: The reason of this Execution2.  # noqa: E501
        :rtype: str
        """
        return self._reason

    @reason.setter
    def reason(self, reason):
        """Sets the reason of this Execution2.


        :param reason: The reason of this Execution2.  # noqa: E501
        :type: str
        """

        self._reason = reason

    @property
    def resumed_at(self):
        """Gets the resumed_at of this Execution2.  # noqa: E501


        :return: The resumed_at of this Execution2.  # noqa: E501
        :rtype: str
        """
        return self._resumed_at

    @resumed_at.setter
    def resumed_at(self, resumed_at):
        """Sets the resumed_at of this Execution2.


        :param resumed_at: The resumed_at of this Execution2.  # noqa: E501
        :type: str
        """

        self._resumed_at = resumed_at

    @property
    def stage_order(self):
        """Gets the stage_order of this Execution2.  # noqa: E501


        :return: The stage_order of this Execution2.  # noqa: E501
        :rtype: list[str]
        """
        return self._stage_order

    @stage_order.setter
    def stage_order(self, stage_order):
        """Sets the stage_order of this Execution2.


        :param stage_order: The stage_order of this Execution2.  # noqa: E501
        :type: list[str]
        """

        self._stage_order = stage_order

    @property
    def stages(self):
        """Gets the stages of this Execution2.  # noqa: E501


        :return: The stages of this Execution2.  # noqa: E501
        :rtype: dict(str, StageExecution1)
        """
        return self._stages

    @stages.setter
    def stages(self, stages):
        """Sets the stages of this Execution2.


        :param stages: The stages of this Execution2.  # noqa: E501
        :type: dict(str, StageExecution1)
        """

        self._stages = stages

    @property
    def starred(self):
        """Gets the starred of this Execution2.  # noqa: E501


        :return: The starred of this Execution2.  # noqa: E501
        :rtype: PipelineStarredProperty
        """
        return self._starred

    @starred.setter
    def starred(self, starred):
        """Sets the starred of this Execution2.


        :param starred: The starred of this Execution2.  # noqa: E501
        :type: PipelineStarredProperty
        """

        self._starred = starred

    @property
    def status(self):
        """Gets the status of this Execution2.  # noqa: E501


        :return: The status of this Execution2.  # noqa: E501
        :rtype: str
        """
        return self._status

    @status.setter
    def status(self, status):
        """Sets the status of this Execution2.


        :param status: The status of this Execution2.  # noqa: E501
        :type: str
        """
        allowed_values = ["NOT_STARTED", "STARTED", "RUNNING", "CANCELING", "WAITING", "RESUMING", "PAUSING", "PAUSED", "CANCELED", "COMPLETED", "FAILED", "SKIPPED", "QUEUED", "FAILED_CONTINUE", "ROLLING_BACK", "ROLLBACK_FAILED", "PREPARING_WORKSPACE", "ROLLBACK_COMPLETED"]  # noqa: E501
        if status not in allowed_values:
            raise ValueError(
                "Invalid value for `status` ({0}), must be one of {1}"  # noqa: E501
                .format(status, allowed_values)
            )

        self._status = status

    @property
    def status_message(self):
        """Gets the status_message of this Execution2.  # noqa: E501


        :return: The status_message of this Execution2.  # noqa: E501
        :rtype: str
        """
        return self._status_message

    @status_message.setter
    def status_message(self, status_message):
        """Sets the status_message of this Execution2.


        :param status_message: The status_message of this Execution2.  # noqa: E501
        :type: str
        """

        self._status_message = status_message

    @property
    def tags(self):
        """Gets the tags of this Execution2.  # noqa: E501

        A set of tag keys and optional values that were set on on the resource.  # noqa: E501

        :return: The tags of this Execution2.  # noqa: E501
        :rtype: list[str]
        """
        return self._tags

    @tags.setter
    def tags(self, tags):
        """Sets the tags of this Execution2.

        A set of tag keys and optional values that were set on on the resource.  # noqa: E501

        :param tags: The tags of this Execution2.  # noqa: E501
        :type: list[str]
        """

        self._tags = tags

    @property
    def updated_at(self):
        """Gets the updated_at of this Execution2.  # noqa: E501

        Date when the entity was last updated. The date is in ISO 8601 with time zone.  # noqa: E501

        :return: The updated_at of this Execution2.  # noqa: E501
        :rtype: str
        """
        return self._updated_at

    @updated_at.setter
    def updated_at(self, updated_at):
        """Sets the updated_at of this Execution2.

        Date when the entity was last updated. The date is in ISO 8601 with time zone.  # noqa: E501

        :param updated_at: The updated_at of this Execution2.  # noqa: E501
        :type: str
        """

        self._updated_at = updated_at

    @property
    def updated_by(self):
        """Gets the updated_by of this Execution2.  # noqa: E501

        The user that last updated this entity  # noqa: E501

        :return: The updated_by of this Execution2.  # noqa: E501
        :rtype: str
        """
        return self._updated_by

    @updated_by.setter
    def updated_by(self, updated_by):
        """Sets the updated_by of this Execution2.

        The user that last updated this entity  # noqa: E501

        :param updated_by: The updated_by of this Execution2.  # noqa: E501
        :type: str
        """

        self._updated_by = updated_by

    @property
    def version(self):
        """Gets the version of this Execution2.  # noqa: E501

        Version of the resource.  # noqa: E501

        :return: The version of this Execution2.  # noqa: E501
        :rtype: str
        """
        return self._version

    @version.setter
    def version(self, version):
        """Sets the version of this Execution2.

        Version of the resource.  # noqa: E501

        :param version: The version of this Execution2.  # noqa: E501
        :type: str
        """

        self._version = version

    @property
    def workspace_results(self):
        """Gets the workspace_results of this Execution2.  # noqa: E501


        :return: The workspace_results of this Execution2.  # noqa: E501
        :rtype: list[WorkspaceResult1]
        """
        return self._workspace_results

    @workspace_results.setter
    def workspace_results(self, workspace_results):
        """Sets the workspace_results of this Execution2.


        :param workspace_results: The workspace_results of this Execution2.  # noqa: E501
        :type: list[WorkspaceResult1]
        """

        self._workspace_results = workspace_results

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(Execution2, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Execution2):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
